<?php

namespace forge12\contactform7\CF7Captcha {

    use forge12\contactform7\CF7Captcha\core\log\Log_Item;
    use forge12\contactform7\CF7Captcha\core\log\Log_WordPress;

    if (!defined('ABSPATH')) {
        exit;
    }

    /**
     * Class CF7HoneypotCaptcha
     */
    class CF7HoneypotCaptcha
    {
        private static $_instance = null;

        public static function getInstance()
        {
            if (self::$_instance == null) {
                self::$_instance = new CF7HoneypotCaptcha();
            }
            return self::$_instance;
        }

        protected function __construct()
        {
            add_filter('wpcf7_form_elements', array($this, 'addCaptcha'), 100, 1);
            add_filter('wpcf7_spam', array($this, 'isSpam'), 100, 2);
        }

        public function addCaptcha($content)
        {
            $captcha = '<span class="wpcf7-form-control-wrap" style="width:0; height:0; max-width:0; max-height:0; opacity:0; display:inline-block;"><input type="text" name="f12_honey" value="" style="width:0px; height:0px; opacity:0; max-width:0; max-height:0;"/></span>';
            return $content . $captcha;
        }

        public static function isSpam($spam, $submission)
        {
            if ($spam) {
                return $spam;
            }

            if (isset($_POST['f12_honey']) && !empty($_POST['f12_honey'])) {
                $spam = true;
            }

            if($spam){
                /*
                 * Add Log Entries
                 */
                $Log_Item = new Log_Item(
                    __('CF7 Fom - Honeypot Validator', 'f12-captcha'),
                    $_POST,
                    'spam',
                    'Honeypot failed in CF7HoneypotCaptcha.class.php');
                Log_WordPress::store($Log_Item);
            }

            return $spam;
        }
    }
}