<?php

namespace forge12\contactform7\CF7Captcha {
    if (!defined('ABSPATH')) {
        exit;
    }

    /**
     * Class UICaptcha
     */
    class UICaptcha extends UIPage
    {
        public function __construct($domain)
        {
            parent::__construct($domain, 'captcha', 'Captcha');
            add_action('f12_cf7_captcha_ui_db_after_content', array($this, 'theContentCaptchaReset'), 10, 1);
            add_filter('f12_cf7_captcha_ui_db_before_on_save', array($this, 'clean'), 10, 1);
        }

        public function theContentCaptchaReset($settings)
        {
            $entries = Captcha::getCount();
            $validated = Captcha::getCount(1);
            $nonValidated = Captcha::getCount(0);

            ?>
            <div class="option">
                <div class="label">
                    <label for="protect_comments"><?php _e('Captchas', $this->domain); ?></label>
                </div>
                <div class="input">
                    <!-- SEPARATOR -->
                    <p style="margin-top:0;">
                        <strong><?php _e('Delete Database Captcha Entries', $this->domain); ?></strong>
                    </p>
                    <p>
                        <?php _e('This entries will be deleted using a WP Cronjob. If you want to reset it manually, use the buttons below.', $this->domain); ?>
                    </p>
                    <p>
                        <strong><?php _e('Entries:', $this->domain); ?></strong>
                        <?php printf(__('%s entries in the database', $this->domain), $entries); ?>
                    </p>
                    <p>
                        <strong><?php _e('Validated:', $this->domain); ?></strong>
                        <?php printf(__('%s entries in the database', $this->domain), $validated); ?>
                    </p>
                    <p>
                        <strong><?php _e('Non-Validated:', $this->domain); ?></strong>
                        <?php printf(__('%s entries in the database', $this->domain), $nonValidated); ?>
                    </p>
                    <input type="submit" class="button" name="captcha-clean-all"
                           value="<?php _e('Delete All', $this->domain); ?>"/>
                    <input type="submit" class="button" name="captcha-clean-validated"
                           value="<?php _e('Delete Validated', $this->domain); ?>"/>
                    <input type="submit" class="button" name="captcha-clean-nonvalidated"
                           value="<?php _e('Deleted Non-Validated', $this->domain); ?>"/>
                    <p>
                        <?php _e('Make sure to backup your database before clicking one of these buttons.', $this->domain); ?>
                    </p>
                </div>
            </div>
            <?php
        }

        public function hideInMenu()
        {
            return true;
        }

        /**
         * @private WP HOOK
         */
        public function getSettings($settings)
        {
            return $settings;
        }

        /**
         * Save on form submit
         */
        protected function onSave($settings)
        {
            return $settings;
        }

        public function clean($settings)
        {
            $Cleaner = new CaptchaCleaner();
            if (isset($_POST['captcha-clean-all'])) {
                if ($Cleaner->resetTable()) {
                    Messages::getInstance()->add(__('Captchas removed from database', $this->domain), 'success');
                } else {
                    Messages::getInstance()->add(__('Something went wrong, please try again later or contact the plugin author.', $this->domain), 'error');
                }
            }
            if (isset($_POST['captcha-clean-validated'])) {
                if ($Cleaner->cleanValidated()) {
                    Messages::getInstance()->add(__('Validated Captchas removed from database', $this->domain), 'success');
                } else {
                    Messages::getInstance()->add(__('Something went wrong, please try again later or contact the plugin author.', $this->domain), 'error');
                }
            }
            if (isset($_POST['captcha-clean-nonvalidated'])) {
                if ($Cleaner->cleanNonValidated()){
                    Messages::getInstance()->add(__('Non Validated Captchas removed from database', $this->domain), 'success');
                } else {
                    Messages::getInstance()->add(__('Something went wrong, please try again later or contact the plugin author.', $this->domain), 'error');
                }
            }

            return $settings;
        }

        /**
         * Render the license subpage content
         */
        protected function theContent($slug, $page, $settings)
        {
        }

        protected function theSidebar($slug, $page)
        {
        }
    }
}