<?php

namespace forge12\contactform7\CF7Captcha {
    if (!defined('ABSPATH')) {
        exit;
    }

    /**
     * Class UILog
     */
    class UILog extends UIPage
    {
        public function __construct($domain)
        {
            parent::__construct($domain, 'log', 'Log Settings', 99);
        }


        protected function onSave($settings)
        {
            foreach ($settings['logs'] as $key => $value) {
                if (isset($_POST[$key])) {
                    $settings['logs'][$key] = (int)$_POST[$key];
                } else {
                    $settings['logs'][$key] = 0;
                }
            }
            return $settings;
        }

        /**
         * Render the license subpage content
         */
        protected function theContent($slug, $page, $settings)
        {
            $settings = $settings['logs'];
            ?>
            <h2>
                <?php _e('Log Settings', $this->domain); ?>
            </h2>

            <div class="option">
                <div class="label">
                    <label for="enable"><?php _e('Status', $this->domain); ?></label>
                </div>
                <div class="input">
                    <!-- SEPARATOR -->
                    <p style="margin-top:0;"><strong><?php _e('Enable Logging', $this->domain); ?></strong></p>
                    <input
                            id="enable"
                            type="checkbox"
                            value="1"
                            name="enable"
                        <?php echo isset($settings['enable']) && $settings['enable'] === 1 ? 'checked="checked"' : ''; ?>
                    />
                    <span>
                        <?php _e('If enabled, all submitted forms will be tracked within the log entries.', $this->domain); ?>
                    </span>
                </div>
            </div>

            <?php
        }

        /**
         * @param $slug
         * @param $page
         *
         * @return void
         */
        protected function theSidebar($slug, $page)
        {
            return;
            ?>
            <div class="box">
                <h2>
                    <?php _e('Hint:', $this->domain); ?>
                </h2>
                <p>
                    <?php _e("", $this->domain); ?>
                </p>
            </div>
            <?php
        }

        /**
         * @param $settings
         *
         * @return mixed
         */
        public function getSettings($settings)
        {
            $settings['logs'] = array(
                'enable' => 1,
            );

            return $settings;
        }

    }
}